package CircularDoublyLinkedList;

import java.util.ListIterator;

public class CircularDoublyLinkedListDriver {

    public static void main(String[] args) {
        // TODO Auto-generated method stub
        try {
            int index = CircularDoublyLinkedList.ITEM_NOT_FOUND;
            CircularDoublyLinkedList<String> firstList = new CircularDoublyLinkedList<String>();
            CircularDoublyLinkedList<String> secondList = new CircularDoublyLinkedList<String>();
            boolean success = false;

            // add method
            System.out.println("=== Test Add method===");
            firstList.add("This");
            System.out.println(firstList);
            firstList.add(1, "is");
            System.out.println(firstList);
            firstList.add(2, "a");
            System.out.println(firstList);
            firstList.add(3, "test");
            System.out.println(firstList);
            firstList.add(4, ".");            
            System.out.println("Result should be: ->This->is->a->test->.");
            System.out.println(firstList);

            // addAll method
            System.out.println("=== Test addAll method===");
            secondList.add("Test");
            secondList.add("ADD");
            secondList.add("All");
            firstList.addAll(2, secondList);
            secondList.clear();
            System.out.println("Result should be: ->This->is->Test->ADD->All->a->test->.");
            System.out.println(firstList);

            // listIterator
            System.out.println("=== Test listIterator===");
            int i = firstList.size();
            ListIterator<String> itr = firstList.listIterator();
            System.out.println("Checking listIterator next");
            for (int n = 0; n < i; n++) {
                System.out.println("(" + itr.next() + ") ");
            }
            System.out.println("Checking listIterator previous");
            for (int n = 0; n < i; n++) {
                System.out.println("(" + itr.previous() + ") ");
            }

            // set method
            System.out.println("=== Test Set method===");
            System.out.println("Set the element of index 2: to \"not\"");
            firstList.set(2, "not");
            System.out.println("Result should be: ->This->is->not->ADD->All->a->test->.");
            System.out.println(firstList);

            // get method
            System.out.println("=== Test Get method===");
            System.out.println("Result should be: not");
            System.out.println("Get the element of index 2: " + firstList.get(2));

            // remove method
            System.out.println("=== Test Remove method===");
            System.out.println("Remove the element \".\"");
            firstList.remove(".");
            System.out.println("Result should be: ->This->is->not->ADD->All->a->test");
            System.out.println(firstList);

            // removeAll method
            System.out.println("=== Test RemoveAll method===");
            System.out.println("Add \"ADD\" and \"ALL\" to te second list");            
            secondList.add("ADD");
            secondList.add("ALL");
            System.out.println("Second list: " + secondList);
            success = firstList.removeAll(secondList);
            secondList.clear();
            if (success == true)
                System.out.println("RemoveAll method working");
            else
                System.out.println("RemoveAll method does not work");
            System.out.println("Result should be: ->This->is->not->a->test");
            System.out.println(firstList);

            // subList method
            System.out.println("=== Test subList method===");
            System.out.println("firstList.subList(1, 2)");
            System.out.println("Result should be: [is, not]");
            System.out.println(firstList.subList(1, 2));

            // containsAll method
            System.out.println("=== Test containsAll method===");
            secondList.add("is");
            secondList.add("not");
            System.out.println("First List: " + firstList);
            System.out.println("Second List: " + secondList);
            System.out.println("firstList.containsAll(secondList)");
            success = firstList.containsAll(secondList);
            secondList.clear();
            if (success == true)
                System.out.println("ContainsAll method working");
            else
                System.out.println("ContainsAll method does not work");

            // equals method
            System.out.println("=== Test equals method===");
            System.out.println(firstList);
            System.out.println("Checking with: This is not a test");
            secondList.add(0, "This");
            secondList.add(1, "is");
            secondList.add(2, "not");
            secondList.add(3, "a");
            secondList.add(4, "test");
            System.out.println("First List: " + firstList);
            System.out.println("Second List: " + secondList);
            System.out.println("firstList.equals(secondList)");
            success = firstList.equals(secondList);
            secondList.clear();
            if (success == true)
                System.out.println("Equals method working");
            else
                System.out.println("Equals method does not work");

            // clone method
            System.out.println("=== Test equals method===");
            System.out.println("Result should be: ->This->is->not->a->test");
            System.out.println(firstList.clone());

            // indexOf method
            System.out.println("=== Test indexOf method===");
            System.out.println("Result Should be: 2");
            System.out.println("The index of not in firstList: " + firstList.indexOf("not"));

            // lastIndexOf method
            System.out.println("=== Test lastIndexOf method===");
            secondList.add("not");
            secondList.add("is");
            secondList.add("not");
            secondList.add("?");
            System.out.println("List: " + secondList);
            System.out.println("Result Should be: 2");
            System.out.println("The index of \"not\" in firstList: " + secondList.lastIndexOf("not"));
            secondList.clear();

            // retainAll method
            System.out.println("=== Test retainAll method===");
            secondList.add("This");
            secondList.add("is");
            firstList.retainAll(secondList);
            secondList.clear();
            System.out.println("Result should be: This is");
            System.out.println(firstList);

            // size method
            System.out.println("=== Test size method===");
            System.out.println("Result should be: 2");
            System.out.println("firstList's size is: " + firstList.size());

            // toArray method
            System.out.println("=== Test toArray method===");
            System.out.println("Result should be: This is");
            Object[] array = firstList.toArray();
            for (int n = 0; n < array.length; n++) {
                System.out.println(array[n] + " ");
            }

            // clear method
            System.out.println("=== Test clear method===");
            firstList.clear();
            System.out.println("firstList: " + firstList);

            // isEmpty method
            System.out.println("=== Test isEmpty method===");
            success = firstList.isEmpty();
            if (success == true)
                System.out.println("This is Empty list");
            else
                System.out.println("This is not Empty list");
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

}
